const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const maritalStatusService = require('./maritalStatus.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.post('/option-free', option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new maritalStatus
 * @param {Object} req.body - The maritalStatus data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created maritalStatus
 */
function create(req, res, next) {
    maritalStatusService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all maritalStatuss
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of maritalStatuss
 */
function getAll(req, res, next) {
    maritalStatusService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of maritalStatus objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of maritalStatus objects
 */
function option(req, res, next) {
    maritalStatusService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of maritalStatuss matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of maritalStatuss
 */
function count(req, res, next) {
    maritalStatusService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing maritalStatus
 * @param {number} req.params.id - The maritalStatus ID to be updated
 * @param {Object} req.body - The maritalStatus data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated maritalStatus
 */
function update(req, res, next) {
    maritalStatusService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Enable or disable a maritalStatus
 * @param {number} req.params.id - The maritalStatus ID to be enabled/disabled
 * @param {Object} req.body - The maritalStatus data to be updated
 * @param {boolean} req.body.enabled - The enabled status of the maritalStatus
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the enable/disable process
 */
function enabled(req, res, next) {
    maritalStatusService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a maritalStatus
 * @param {number} req.params.id - The maritalStatus ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    maritalStatusService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
